#include <unistd.h>
#include <File.h>
#include <Message.h>
#include <Resources.h>
#include <stdio.h>
#include <string.h>
#include "db.h"

int main(int argc, const char **argv) {
	char home[255], shell[255], user[255], pwd[255];
	home[0] = 0;
	shell[0] = 0;
	user[0] = 0;
	pwd[0] = 0;
	uid_t uid = UINT_MAX;
	gid_t gid = 0;
	
	if (argc < 3) {
		usage:
		printf(	"adduser usage -\n"
				"\tadduser [options] user_name initial_password\n"
				"\t\twhere options is one or more of the following\n"
				"\t\t-s shell\tshell is the full path to the shell, default is /bin/sh\n"
				"\t\t-g gid\t\tgid is the numerical group number, default is 0\n"
				"\t\t-u uid\t\tuid is the numerical user id, default is the next available uid\n"
				"\t\t-h home\t\thome is the path to the user's home directory, default is /boot/home/user_name\n\n"
				
				"adduser -u 1543 -s /bin/zsh nathanw changeme\n");
		return 0;
	}
	for (int32 i = 1; i < argc; i++) {
		if ((argv[i][0] == '-') && ((i + 1) < argc)) {
			switch (argv[i][1]) {
				case 's':
					strcpy(shell,argv[i+1]);
					break;
				case 'g':
					sscanf(argv[i+1],"%d",&gid);
					break;
				case 'u':
					sscanf(argv[i+1],"%d",&uid);
					break;
				case 'h':
					strcpy(home,argv[i+1]);
					break;
				default:
					printf("Ignoring unknown option -%c.\n",argv[i][1]);
					break;
			}
			i++; //-----Increment twice to skip opt and value-----
		} else {
			if (user[0] == 0)
				strcpy(user,argv[i]);
			else
				strcpy(pwd,argv[i]);
		}
	}
	if (getuid() != 0) {
		printf("You must be root to run this program. Sorry.\n");
		return -1;
	}
	if ((user[0] == 0) || (pwd[0] == 0)) {
		goto usage;
	}
	InitDB(false);
	BMessage user_data;
	if (status < 0) {
		printf("Help! Could not create user file.\n");
		return -3;
	}
	if (HasEntry(user)) {
		printf("User %s already exists. Either delete this user or modify them to proceed.\n",user);
		return -4;
	}
	if (HasEntry(uid)) {
		printf("A user with uid %d already exists. Please specify a different user id.\n",uid);
		return -5;
	}
	
	//------Build user info------
	user_data.AddInt64("gid",gid);
	if (shell[0] != 0)
		user_data.AddString("shell",shell);
	if (home[0] != 0)
		user_data.AddString("home",home);
	user_data.AddString("password",encrypt_pwd(pwd));
	
	//------Add to Resource------
	SetDBEntry(&user_data,uid,user);

	printf("User %s added successfully in group %d with uid %d!\n",user,gid,uid);
	return 0;
}